\documentclass[a4paper,10pt]{article}

\begin{document}

\title{\textbf{SLOB allocator}}
\author{Pawel Dziepak}
\date{\textit{July 25, 2008}}
\maketitle

\section{Introduction}
\paragraph{}SLOB (Simple List of Blocks) allocator was designed and created by Matt Mackall
to use it in Linux kernel while working on embedded system. Its advantages
are speed and small size of stored metadata. On the other hand SLOB allocator
memory quickly gets fragmented.

\section{Algorithm}
\paragraph{}SLOB is based on standard K\&R (Kernighan \& Ritchie) heap allocator. It stores
lists of memory areas that are allocated. When system needs more space on heap
allocator goes through the areas and looks for a space between two blocks that
is big enough to fit new object. If none is found algorithm allocate memory
after the last block. SLOB uses first-fit policy which can be easily replaced
(by inheritance of slob class and replacing slob::allocate method) with other
policies such as best-fit.

\section{More information}
\paragraph{}The message on LKML by Matt Mackall introducing SLOB to Linux is mirrored
at this URL: http://lkml.org/lkml/2005/11/1/230

\end{document}
